/* broker.h */

#ifndef BROKER_H_
#define BROKER_H_

int debug;

char version[] = "0.44";

struct InfoType Info[MAXTHREADS];
PRLock *InfoMutex;
struct mainThreadType mainThread;
PRLock *mainThreadMutex;

// global because stopdaemon needs it
PRFileDesc *listenSock;
int StopDaemon = FALSE;

// this should become an array some day
void *BlendFile;
LONGINT BlendFileSize;

// Mutex stuff (BA == BlenderAction)
#define BA_NOACTION 0
#define BA_NEWBLENDFILE 1
#define BA_SINGLESHOTRENDER 2
#define BA_QUIT 3
#define BA_STOPALLDAEMONS 4
int BlenderAction;
int Job;
PRLock *BlenderActionMutex;
PRCondVar *BlenderActionCondition;

// Broker Copy stuff
#define B_TASK 0
#define B_INITIALIZE 1
#define B_WORK 2
#define B_RESET 3
#define B_DONE 4
int brokerWorkDone;
char *brokerScanDir;
char *brokerCopyFrom;
char *brokerCopyTo;

// failed frame / brokerJob values
#define B_NOFRAME 0
#define B_INITIALIZE 1
#define B_CURRENT 2
#define B_INCOMPLETE 3
#define B_COMPLETE 4

// more mutex stuff
#define STARTLIMIT 1
#define ENDLIMIT 2
#define COMPLETE 3
#define INCOMPLETE 4

struct SingleShotTag {
	//	char *scene;			For someday to enable multi-scene blend files
	int start;
	int end;
	int frame;
	//int complete;
	} SingleShot;
PRLock *SingleShotMutex;
PRCondVar *SingleShotCondition;

// Job info structure.
struct brokerJobTag {
	int jobID;
	char *BlendFileName;
	PRInt32 BlendFileSize;
	int start;  // Start frame
	int end;	// End frame
	char *scene;	// Scene name
	int status; // initial, current, incomplete, complete
	PRTime epoch;
	PRTime epochFinish;
	} brokerJob;


struct twoports port;

// to store the configuration information
ConfigInfo *configInfo;

// Function declarations
void PR_CALLBACK broker_control(void *arg);
void PR_CALLBACK broker_thread(void *);
void print_help();
static void blender_esc(int sig);
void SignalThreads(int signal);
void SetFrameLimit(int limittype, int limit);
int read_blenderfile(PRFileDesc *brokersockfd, char *BlendFileName);
void brokerFileCopy (char *brokerCopyFrom, char *brokerCopyTo);
void brokerScan(char *brokerScanDir);

void showhelp(PRFileDesc *sockfd);
void showconfig(PRFileDesc *sockfd);
void showstatus(struct threadArgsType *args);
void stopdaemon(PRFileDesc *sockfd);
void stopalldaemons(PRFileDesc *sockfd);
void newrenderd(struct threadArgsType *args, char *linep);

void SaveFrame(struct threadArgsType *args, char *FrameName, LONGINT FrameSize);

void PR_CALLBACK brokertorenderd(void *);
void brokerScan(char *brokerScanDir);

void send_BlendFile(struct threadArgsType *args);
int receive_BlendFile(PRFileDesc *sockfd);

#endif
