/* common.h
 * Copyright (c) 2000 by Not a Number B.V. (NaN) and Hans Lambermont.
 * This file is covered by the license in the accompanying "LICENSE" file.
 * $Id: common.h 43 2004-04-22 04:47:11Z mcbridea $
 */

#ifndef COMMON_H
#define COMMON_H

#define MAXLINE    2048
// actually MAXTHREADS - 5 because we really count filedescriptors here
#define MAXTHREADS 30 

extern char version[];

struct threadArgsType {
	// incoming connection connected to:
	int fd;
	PRFileDesc *sock;
	PRNetAddr addr;

	// old port-server-pair struct, for broker
	int port;
	char server[MAXLINE];

	// broker thread connects to renderd at:
	int fd2;
	PRFileDesc *sock2;
	PRNetAddr addr2;
};

// occupied file descriptors and statistics Info
struct InfoType {
	int occupied;
	char ip[PR_NETDB_BUF_SIZE];
	int port;
	PRTime epoch;
	int frames_rendered;
	LONGINT msecPerFrame;
};

extern struct InfoType Info[MAXTHREADS];

// InfoType struct thread synchronisation
extern PRLock *InfoMutex;

// main thread (broker and renderd) statistics
struct mainThreadType {
	int renderThreadfd;
	int frames_rendered;
	PRTime epoch;
	LONGINT msecPerFrame;
	PRFileDesc *nsprfd[MAXTHREADS];

	// should broker periodically check for new
	// .blend files in brokertasks/ dir ?
	int blendFilePolling;

	// what's our current activity ?
	// See also the MT_STATUS below
	int status;
};

extern struct mainThreadType mainThread;

// mainThread struct thread synchronisation
extern PRLock *mainThreadMutex;

#define MT_STATUS_ACTIVE 1
#define MT_STATUS_IDLE 2
#define MT_STATUS_INITIALIZE 3

#endif
