/* nspr-additions.h
 * Copyright (c) 2000 by Not a Number B.V. (NaN) and Hans Lambermont.
 * This file is covered by the license in the accompanying "LICENSE" file.
 * $Id: nspr-additions.h 43 2004-04-22 04:47:11Z mcbridea $
 */

#ifndef NSPR_ADDITIONS_H
#define NSPR_ADDITIONS_H

#ifndef TRUE
	#define TRUE 1
	#define FALSE 0
#endif

#ifndef LONGINT
	#define LONGINT long int
#endif

char *PRB_ErrorText(PRErrorCode err);
char *PRB_GetErrorText();

PRInt32 PRB_Send(PRFileDesc *fd, void *buf, PRInt32 amount,
		  PRIntn flags, PRIntervalTime timeout);
void PRB_Msg(PRFileDesc *fd, const char *fmt, ...);
PRInt32 PRB_Recv(PRFileDesc *fd, void *buf, PRInt32 amount,
		  PRIntn flags, PRIntervalTime timeout);
PRInt32 PRB_ReadLineTime(PRFileDesc *fd, char *buf, PRUint32 bufSize,
			PRIntervalTime timeout);
void PRB_Close(PRFileDesc *fd);
void PRB_sprintExplodedTime(char *string, const PRExplodedTime *et);
void PRB_SecondsToString(char *uptimeString, LONGINT seconds);
int PRB_GetFileDesc(PRFileDesc *fd);

#define PRB_ReadLine(fd, buf, bufSize)	\
	PRB_ReadLineTime(fd, buf, bufSize, PR_INTERVAL_NO_TIMEOUT)

/* Get the bytes out of an IPv4 address */
#define HH(i) ( (i >> 24) & 0xff )
#define HM(i) ( (i >> 16) & 0xff )
#define LM(i) ( (i >>  8) & 0xff )
#define LL(i) (i & 0xff )

#define BIP(i) HH(i), HM(i), LM(i), LL(i)

#define BTO(i) PR_MillisecondsToInterval(i)
#define BTO_SEC(i)	BTO(i*1000)
#define BTO_MIN(i)	(i*60*1000)
#define BTO_HOUR(i) (i*60*60*1000)

#define FOREVER PR_INTERVAL_NO_TIMEOUT

#define TO_MSG	BTO_SEC(10)

#define TO_BROKER_LISTEN			  PR_INTERVAL_NO_TIMEOUT
#define TO_BROKER_THREAD_READLINE	  BTO_MIN(3)
#define TO_BROKER_SINGLESHOT_READLINE BTO_MIN(60)
#define TO_BROKER_SAVEFRAME 		  BTO_MIN(1)
#define TO_BROKER_BTR_CONNECT		  BTO_SEC(1)
#define TO_BROKER_BTR_READLINE		  BTO_SEC(1)
#define TO_BROKER_SEND_BF_SEND		  BTO_MIN(1)
#define TO_BROKER_SEND_BF_READLINE	  BTO_MIN(1)
#define TO_BROKER_RECIEVE_BF_RECV	  BTO_MIN(1)
#define TO_BROKER_STOPDAEMON_READLINE BTO_MIN(1)
#define TO_BROKER_STOPALL_READLINE	  BTO_MIN(1)
#define TO_BROKER_SENDTOALL_CONNECT   BTO_SEC(5)
#define TO_BROKER_SENDTOALL_READLINE  BTO_SEC(5)

#endif
